﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GenerateChart
{
    public class FullRangeDataCollection : ObservableCollection<RangeDataPoint>
    {
        public FullRangeDataCollection()
        {
            Random random = new Random();

            string toolTip = "The tooltip";

            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-26 07:25:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-26 10:16:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-26 14:45:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-27 08:25:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-27 11:25:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-27 15:25:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-28 07:17:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-28 11:35:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-28 14:54:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-29 07:04:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });
            this.Add(new RangeDataPoint() { Label = DateTime.Parse("2019-07-29 12:25:00.000"), Value = random.NextDouble() * (15 - 0) + 0, ToolTip = toolTip });


            DateTime startingDTM = new DateTime(this[0].Label.Year, this[0].Label.Month, this[0].Label.Day, 0, 0, 0);
            DateTime endingDTM = new DateTime(this.Last().Label.Year, this.Last().Label.Month, this.Last().Label.Day, 0, 0, 0).AddDays(1);

            this.InsertItem(0, new RangeDataPoint() { Label = startingDTM, Value = double.NaN });
            this.InsertItem(this.Count, new RangeDataPoint() { Label = endingDTM, Value = double.NaN });

        }
    }
    /// <summary>
    /// Simple storage class for pair of string and double value
    /// </summary>
    public class RangeDataPoint
    {
        public double Value { get; set; }
        public DateTime Label { get; set; }
        public string ToolTip { get; set; }
    }

}
